---
# roles/kvm/tasks/main.yml

## Package management

- name: "Manage kvm Packages"
  ansible.builtin.package:
    name: "{{ kvm_package_names }}"
    state: "{{ kvm_package_state }}"
  become: true
  tags:
    - "kvm"
    - "package"

- name: "Manage kvm-client Packages"
  ansible.builtin.package:
    name: "{{ kvm_client_package_names }}"
    state: "{{ kvm_client_package_state }}"
  become: true
  when:
    - "kvm_package_state != 'absent'"
  tags:
    - "kvm"
    - "package"

- name: "Manage ksm Packages"
  ansible.builtin.package:
    name: "{{ kvm_ksm_package_names }}"
    state: "{{ kvm_ksm_package_state }}"
  become: true
  when:
    - "kvm_package_state != 'absent'"
  tags:
    - "kvm"
    - "ksm"
    - "package"

## Configuration management

- name: "Manage kvm nested Configuration"
  ansible.builtin.lineinfile:
    path: "/etc/modprobe.d/kvm.conf"
    # yamllint disable-line rule:line-length
    line: "options kvm_{{ ansible_processor | join(', ') | regex_search('(Intel|AMD)') | lower() }} nested=1"
    owner: "root"
    group: "root"
    mode: 0644
  become: true
  when:
    - "kvm_package_state != 'absent'"
    - "kvm_configuration_nested_virtualization_enabled | bool"
    - "ansible_processor | join(', ') | regex_search('(Intel|AMD)') != ''"
  tags:
    - "kvm"
    - "configuration"

## Service management

- name: "Manage kvm Service"
  ansible.builtin.service:
    name: "{{ kvm_service_name }}"
    state: "{{ kvm_service_state }}"
    enabled: "{{ kvm_service_enabled }}"
  become: true
  when:
    - "kvm_package_state != 'absent'"
  tags:
    - "kvm"
    - "service"

- name: "Manage ksm Service"
  ansible.builtin.service:
    name: "{{ kvm_ksm_service_name }}"
    state: "{{ kvm_ksm_service_state }}"
    enabled: "{{ kvm_ksm_service_enabled }}"
  become: true
  when:
    - "kvm_package_state != 'absent'"
    - "kvm_ksm_package_state != 'absent'"
  tags:
    - "kvm"
    - "ksm"
    - "service"
...
